function [mu_bar,sigma_bar] = predict(mu,sigma,uv,uw,dt,alpha,alpharot)

if ( ( uv == 0 ) && ( uw == 0 ) ) 
    mu_bar = mu;
    sigma_bar = sigma;
    return;
end

M = zeros(2,2);
R = zeros(3,3);
G = zeros(3,3);
V = zeros(3,2);

mu_bar = zeros(size(mu));

theta = mu(3);

if ( uw ~= 0 )

    mu_bar(1) = mu(1) - (uv/uw)*sin(theta)+(uv/uw)*sin(theta+uw*dt);
    mu_bar(2) = mu(2) + (uv/uw)*cos(theta)-(uv/uw)*cos(theta+uw*dt);
    mu_bar(3) = mu(3) + uw*dt;

    G(1,1) = 1;
    G(1,3) = -(uv/uw)*cos(theta)+(uv/uw)*cos(theta+uw*dt);
    G(2,2) = 1;
    G(2,3) = -(uv/uw)*sin(theta)+(uv/uw)*sin(theta+uw*dt);
    G(3,3) = 1;

    V(1,1) = (-sin(theta)+sin(theta+uw*dt))/uw;
    V(1,2) = uv*(sin(theta)-sin(theta+uw*dt))/(uw^2)+ uv*cos(theta+uw*dt)*dt/uw;
    V(2,1) = (cos(theta)-cos(theta+uw*dt))/uw;
    V(2,2) =  -uv*(cos(theta)-cos(theta+uw*dt))/(uw^2) + uv*sin(theta+uw*dt)*dt/uw;
    V(3,2) = dt;

else

    mu_bar(1) = mu(1) + uv*cos(theta)*dt;
    mu_bar(2) = mu(2) + uv*sin(theta)*dt;
    mu_bar(3) = mu(3);

    G(1,1) = 1;
    G(1,3) = -uv*sin(theta)*dt;
    G(2,2) = 1;
    G(2,3) = uv*cos(theta)*dt;
    G(3,3) = 1;

    V(1,1) = cos(theta);
    V(2,1) = sin(theta);

end

M(1,1) = alpha(1)*(uv^2) + alpha(2)*(uw^2);
M(2,2) = alpha(3)*(uv^2) + alpha(4)*(uw^2);
R(3,3) = alpharot(1)*(uv^2)+alpharot(2)*(uw^2);


sigma_bar = G*sigma*G'+V*M*V'+R;