
function val = marginalize_pi(theta,x,V,uv,uw,measurements,c,mu,sigma,dt,numIter,Q,fixed)

%% enforces positive components for theta and imposes boundary limits
if ( ( sum(theta>0) < numel(theta) ) || ( min(theta) < 10e-5 ) || ( max(theta) > 10e10 ) )
    val = +inf;
    return;
end

if size(theta,1) < size(theta,2) 
    theta = theta';
end


if size(mu,1) < size(mu,2) 
    mu = mu';
end

alpha = theta;

%Q = ComputeQ(cvfix,measurements);

[x,V,val] = iterate(x,V,numIter,uv,uw,measurements,c,dt,alpha,Q,fixed);

d = (mu-alpha);

%if ( rcond(sigma) > 10e-10 )

    val = val + 0.5*d'*inv(sigma)*d + 0.5*log(det(2*pi*sigma));
%else
 %   val = +inf;
%end

% if sum(teta>0)<Nfix;% | teta(1)<intervallo(1) | teta(2)<intervallo(1) | teta(1)>intervallo(2) |teta(2)>intervallo(2);
%    l=+inf;
% else
%    
%    CV_stim=teta;
%    rv=buildrvfast(CV,CV_stim,y,N);
%    
%    [s,V,l]=kalmaniter(xo,Vo,y,go,Q,rv,iter,v,Dth,xcorr);
%    
%    if size(teta,1)<size(teta,2)
%       teta=teta';
%    end
%    if size(mu,1)<size(mu,2)
%       mu=mu';
%    end
%    
%    d=mu-teta;
%    
%    l=l+0.5*d'*inv(Sigma)*d; 
%    
% end

