%function generate_data(alpha,cvfix,startpose,NSteps)
%function generate_data


NMonte = 500;


for monte = 1:NMonte

     monte
    
%    close all;
    
    alpha = [1.0000000e-01   1.0000000e-01   1.0000000e-01   1.0000000e-01   1.0000000e-02   1.0000000e-02];  %% THESE ARE STANDARD DEVIATIONS
    cvfix = 1.0000000e-01; %% TRUE SENSOR NOISE COVARIANCE
    startpose = [4+2*rand(1) 4+2*rand(1) 2*pi*rand(1)];
    NSteps = 500;
    
    feetToMeters = 0.3048;
    
    [Map,Nfix] = LoadFMap('../data/test1/fMap',feetToMeters);
    
    x = zeros(3,NSteps);
    
    x(:,1) = startpose;
    
   % figure ;
    %plot(trajectory0(:,1),trajectory0(:,2),'r');
   % hold on
  %  grid on
 %   plot(Map(:,2),Map(:,3),'r+');
    
    robData = zeros(NSteps-1,6);
    camData = [];
    
    s = '';
    
    commands = '';
    
    cumulativeTime = 0;
    
    for i = 2:NSteps
        
%        i
        
        %     while ( size(s,2) == 0 )
        %         s = input('Give me the command','s');
        %     end
        
        % random motion generation
        if ( size(s,2) == 0 )
            if ( x(2,i-1) > 1 ) && ( x(2,i-1) < 9 ) && ( x(1,i-1) > 1 ) && ( x(1,i-1) < 9 )
                % inside : move randomly
                gettingback = false;
                left = false;
                right = false;
                p = rand(1);
                if ( p < 0.5 )
                    s = 'fffffffffffff';
                elseif ( p < 0.75 )
                    s = 'rrrrrrrr';
                else
                    s = 'llllllll';
                end
            else %% on the boundaries: get back in
                
                v1 = [cos(x(3,i-1)) sin(x(3,i-1))];
                an = atan2(x(2,i-1)-5,x(1,i-1)-5);
                v2 = [cos(an) sin(an)];
                if ( dot(v1,v2) < -0.8 ) % pointing invards
                    s = 'fffffffffffffffffffffffffffffffff';
                    
                else
                    if ~ gettingback
                        p = rand(1);
                        if p < 0.5
                            s = 'r';
                            right = true;
                            left = false;
                        else
                            s = 'l';
                            right = false;
                            left = true;
                        end
                        gettingback = true;
                    else
                        
                        if right
                            s = 'r';
                        else
                            s = 'l';
                        end
                    end
                end
            end
        end
        
        
        c = s(:,1);
        
        commands = strcat(commands,c);
        
        s = s(:,2:end);
        
        switch(c)
            case 'f'
                uv = 0.1;
                uw = 0;
            case 'l'
                uv = 0.05;
                uw = 0.1;
            case 'r'
                uv  = 0.05;
                uw = -0.1;
            case 'q'
                break
                
        end
        
        robData(i-1,5) = uv;
        robData(i-1,6) = uw;
        
        deltaT = 1 + randn(1)*0.1;
        
        cumulativeTime = cumulativeTime + deltaT;
        
        robData(i-1,1) = cumulativeTime;
        
        % noise corrupted inputs
        uv = uv + randn(1)*sqrt(alpha(1)*uv^2+alpha(2)*uw^2);
        uw = uw + randn(1)*sqrt(alpha(3)*uv^2+alpha(4)*uw^2);
        gamma = randn(1)* sqrt(alpha(5)*uv^2+alpha(6)*uw^2);
        
        x(1,i) = x(1,i-1) - (uv/uw)*sin(x(3,i-1))+(uv/uw)*sin(x(3,i-1)+uw*deltaT);
        x(2,i) = x(2,i-1) + (uv/uw)*cos(x(3,i-1))-(uv/uw)*cos(x(3,i-1)+uw*deltaT);
        x(3,i) = x(3,i-1) + uw*deltaT + gamma*deltaT;
        
        m = get_measures(x(:,i),Map,cvfix,cumulativeTime,5);
        
        if ( isempty(camData) )
            camData = m;
        else
            camData = [ camData ; m ];
        end
        
 %       plot(x(1,1:i),x(2,1:i),'k');
%        pause(0.001);
        
    end
    
    robData = robData(1:i-1,:);
    %camData = camData(1:i-1,:);
    x = x(:,1:i-1)';
    
    basePath = sprintf(' MonteCarlo/exp%i',monte);
    com = strcat('mkdir',basePath);
    system(com);
    
    basePath = sprintf('MonteCarlo/exp%i/',monte);
    
    fname = strcat(basePath,'dRob');
    save(fname,'robData');
    
    fname = strcat(basePath,'dCam');
    save(fname,'camData');
    
    fname = strcat(basePath,'groundTruth');
    save(fname,'x');
    
    fname = strcat(basePath,'commands');
    save(fname,'commands');
    
    fname = strcat(basePath,'alpha');
    save(fname,'alpha');
    
    fname = strcat(basePath,'startpose');
    save(fname,'startpose');
    
    fname = strcat(basePath,'cvfix');
    save(fname,'cvfix');
    
    %     save dRob robData -ascii
    %     save dCam camData -ascii
    %     save groundTruth x -ascii
    %     save commands commands -ascii
    %     save alpha alpha -ascii
    %     save startpose startpose -ascii
    %     save cvfix cvfix -ascii
    
end
