%function generate_data(alpha,cvfix,startpose,NSteps)
%function generate_data

%sigma = [];  %% THESE ARE covariances
alpha = [0.001 0.005 0.005];

cvfix = 0.05; %% TRUE SENSOR NOISE COVARIANCE
startpose = [5 5 0];
NSteps = 1000;

feetToMeters = 0.3048;

[Map,Nfix] = LoadFMap('../data/test1/fMap',feetToMeters);

x = zeros(3,NSteps);

x(:,1) = startpose;

figure ;
%plot(trajectory0(:,1),trajectory0(:,2),'r');
hold on
grid on
plot(Map(:,2),Map(:,3),'r+');

robData = zeros(NSteps-1,6);
camData = [];

s = '';

commands = '';

cumulativeTime = 0;

for i = 2:NSteps
    
    i
    
    while ( size(s,2) == 0 )
        s = input('Give me the command','s');
    end
    
    c = s(:,1);
    
    commands = strcat(commands,c);
    
    s = s(:,2:end);
    
    switch(c)
        case 'f'
            uv = 0.1;
            uw = 0;
        case 'l'
            uv = 0.05;
            uw = 0.1;
        case 'r'
            uv  = 0.05;
            uw = -0.1;
        case 'q'
            break
            
    end
    
    robData(i-1,5) = uv;
    robData(i-1,6) = uw;
    
    deltaT = 1 + randn(1)*0.1;
    
    cumulativeTime = cumulativeTime + deltaT;
    
    robData(i-1,1) = cumulativeTime;
    
    % noise corrupted inputs
    %     uv = uv + randn(1)*sqrt(alpha(1)*uv^2+alpha(2)*uw^2);
    %     uw = uw + randn(1)*sqrt(alpha(3)*uv^2+alpha(4)*uw^2);
    %     gamma = randn(1)* sqrt(alpha(5)*uv^2+alpha(6)*uw^2);
    
    if ( uw ~= 0 )
        
        x(1,i) = x(1,i-1) - (uv/uw)*sin(x(3,i-1))+(uv/uw)*sin(x(3,i-1)+uw*deltaT);
        x(2,i) = x(2,i-1) + (uv/uw)*cos(x(3,i-1))-(uv/uw)*cos(x(3,i-1)+uw*deltaT);
        x(3,i) = x(3,i-1) + uw*deltaT;
        
    else
        
        x(1,i) = x(1,i-1) + uv*cos(x(3,i-1))*deltaT;
        x(2,i) = x(2,i-1) + uv*sin(x(3,i-1))*deltaT;
        x(3,i) = x(3,i-1);
        
    end
    
    x(:,i) = x(:,i) + ([sqrt(alpha(1)) sqrt(alpha(1)) 0].*randn(1,3))';
    x(3,i) = x(3,i) + randn(1)* sqrt(alpha(2)*uv^2+alpha(3)*uw^2);
    
    
    
    m = get_measures(x(:,i),Map,cvfix,cumulativeTime);
    
    if ( isempty(camData) )
        camData = m;
    else
        camData = [ camData ; m ];
    end
    
    plot(x(1,1:i),x(2,1:i),'k');
    pause(0.001);
    
end

robData = robData(1:i-1,:);
%camData = camData(1:i-1,:);
x = x(:,1:i-1)';

save dRob robData -ascii
save dCam camData -ascii
save groundTruth x -ascii
save commands commands -ascii
save alpha alpha -ascii
save startpose startpose -ascii
save cvfix cvfix -ascii

