function [mu_bar,sigma_bar] = predict(mu,sigma,v,w,dt,alpha)


N = round(size(mu,1)/3);

M = zeros(2*N,2*N);
R = zeros(3*N,3*N);
G = zeros(3*N,3*N);
V = zeros(3*N,2*N);

mu_bar = zeros(size(mu));

for i = 1:N
    index = 3*i-2;
    uv = v(i);
    uw = w(i);
    theta = mu(index+2);
    
    if ( i ~= N )
        uv = 0;
        uw = 0;
    end
    
    if ( uw ~= 0 )
        
        mu_bar(index+0) = mu(index+0) - (uv/uw)*sin(theta)+(uv/uw)*sin(theta+uw*dt);
        mu_bar(index+1) = mu(index+1) + (uv/uw)*cos(theta)-(uv/uw)*cos(theta+uw*dt);
        mu_bar(index+2) = mu(index+2) + uw*dt;
        
        G(index+0,index+0) = 1;
        G(index+0,index+2) = -(uv/uw)*cos(theta)+(uv/uw)*cos(theta+uw*dt);
        G(index+1,index+1) = 1;
        G(index+1,index+2) = -(uv/uw)*sin(theta)+(uv/uw)*sin(theta+uw*dt);
        G(index+2,index+2) = 1;
        
        V(3*(i-1)+1,2*(i-1)+1) = (-sin(theta)+sin(theta+uw*dt))/uw;
        V(3*(i-1)+1,2*(i-1)+2) = uv*(sin(theta)-sin(theta+uw*dt))/(uw^2)+ uv*cos(theta+uw*dt)*dt/uw;
        V(3*(i-1)+2,2*(i-1)+1) = (cos(theta)-cos(theta+uw*dt))/uw;
        V(3*(i-1)+2,2*(i-1)+2) =  -uv*(cos(theta)-cos(theta+uw*dt))/(uw^2) + uv*sin(theta+uw*dt)*dt/uw;
        V(3*(i-1)+3,2*(i-1)+2) = dt;
        
    else
        
        mu_bar(index+0) = mu(index+0) + uv*cos(theta)*dt;
        mu_bar(index+1) = mu(index+1) + uv*sin(theta)*dt;
        mu_bar(index+2) = mu(index+2);
        
        G(index+0,index+0) = 1;
        G(index+0,index+2) = -uv*sin(theta)*dt;
        G(index+1,index+1) = 1;
        G(index+1,index+2) = uv*cos(theta)*dt;
        G(index+2,index+2) = 1;
        
        V(3*(i-1)+1,2*(i-1)+1) = cos(theta);
        V(3*(i-1)+2,2*(i-1)+1) = sin(theta);
        
    end
    
    M(2*(i-1)+1,2*(i-1)+1) = alpha(1)*(uv^2) + alpha(2)*(uw^2);
    M(2*(i-1)+2,2*(i-1)+2) = alpha(3)*(uv^2)+alpha(4)*(uw^2);
    R(index+2,index+2) = alpha(5)*(uv^2)+alpha(6)*(uw^2);
end

sigma_bar = G*sigma*G'+V*M*V'+R;