function [mu,sigma,p] = update(mu_bar,sig_bar,z,numIter,c,Q)

mu = mu_bar;
sigma = sig_bar;
N = round(size(mu_bar,1)/3);
movNode = N;
p = 0;

for i = 1:numIter
   
    H = zeros(size(z,1),3*N);
    z_hat = zeros(size(z,1),1);
    for j = 1:size(z,1)
        
        cor = c(j,1); 
        q = (mu(3*cor+1)-mu(3*movNode-2))^2+(mu(3*cor+2)-mu(3*movNode-1))^2;
        
        z_hat(j) = sqrt(q);
        
        % setH
        H(j,3*cor+1) = (mu(3*cor+1)-mu(3*movNode-2))/sqrt(q);
        H(j,3*cor+2) = (mu(3*cor+2)-mu(3*movNode-1))/sqrt(q);
        
        H(j,3*movNode-2) = -(mu(3*cor+1)-mu(3*movNode-2))/sqrt(q);
        H(j,3*movNode-1) = -(mu(3*cor+2)-mu(3*movNode-1))/sqrt(q);
        
    end
    
    S = H * sig_bar * H' + Q;
    
    if ( rcond(S) > 10e-10 )

        K = sig_bar * H' * inv(S);
        sigma = sig_bar - K * H * sig_bar;
        innovation = z - z_hat - H*(mu_bar-mu);
        mu = mu_bar + K * innovation;

        p1 = log(det(2*pi*S));
        p2 = innovation' * inv(S) * innovation;
        p = 0.5 * (p1+p2);
    end
end